unit Main;
interface
uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DelDialog, Grids, ActnList, StdCtrls, Buttons, ComCtrls, ShellCtrls,
  FileCtrl, ExtCtrls, Menus,about,kernel;
type
  TForm1 = class(TForm)
    StringGrid1: TStringGrid;          ActionList1: TActionList;
    Refresh: TAction;                  Save: TAction;
    Load: TAction;                     Delete: TAction;
    Restore: TAction;                  BitBtn4: TBitBtn;
    BitBtn5: TBitBtn;                  BitBtn6: TBitBtn;
    Clearbin: TAction;                 Restoreall: TAction;
    BitBtn1: TBitBtn;                  BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;                  Edit1: TEdit;
    Edit2: TEdit;                      Edit3: TEdit;
    Edit4: TEdit;                      Edit5: TEdit;
    Label1: TLabel;                    BitBtn7: TBitBtn;
    BitBtn8: TBitBtn;                  BitBtn9: TBitBtn;
    BitBtn10: TBitBtn;                 BitBtn11: TBitBtn;
    BitBtn12: TBitBtn;                 Panel1: TPanel;
    CloseOpenPanel: TAction;           DelMask: TAction;
    RestMask: TAction;                 PopupMenu1: TPopupMenu;
    Restore1: TMenuItem;               Delete1: TMenuItem;
    Clearbin1: TMenuItem;              Restoreall1: TMenuItem;
    CloseOpenPanel1: TMenuItem;        BitBtn13: TBitBtn;
    Label2: TLabel;                    Label3: TLabel;
    Label4: TLabel;                    Label5: TLabel;
    Label6: TLabel;
    BitBtn14: TBitBtn;
    procedure FormCreate(Sender: TObject);                   procedure RefreshExecute(Sender: TObject);
    procedure SaveExecute(Sender: TObject);                  procedure LoadExecute(Sender: TObject);
    procedure FormDestroy(Sender: TObject);                  procedure DeleteExecute(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);                 procedure ClearbinExecute(Sender: TObject);
    procedure RestoreallExecute(Sender: TObject);            procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);                 procedure BitBtn7Click(Sender: TObject);
    procedure BitBtn8Click(Sender: TObject);                 procedure BitBtn9Click(Sender: TObject);
    procedure BitBtn10Click(Sender: TObject);                procedure BitBtn11Click(Sender: TObject);
    procedure CloseOpenPanelExecute(Sender: TObject);        procedure DelMaskExecute(Sender: TObject);
    procedure RestMaskExecute(Sender: TObject);              procedure Restore1Click(Sender: TObject);
    procedure BitBtn13Click(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure BitBtn14Click(Sender: TObject);
  private
  public
  end;
var
  Form1: TForm1;
  opened:boolean;

implementation



{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
FList:=TFilelist.Create;
StringGrid1.Cells[0,0]:='';
StringGrid1.Cells[1,0]:='';
StringGrid1.Cells[2,0]:=' ';
StringGrid1.Cells[3,0]:=' ';
StringGrid1.Cells[4,0]:=' ';
StringGrid1.Cells[5,0]:=' ()';
load.Execute;
refresh.Execute;
end;

procedure TForm1.RefreshExecute(Sender: TObject);
var
i:byte;
S:TMyfile;
begin
if FList.Count<>0 then
 begin
 StringGrid1.RowCount:=FList.Count+1;
 for i:=0 to FList.Count-1 do
  begin
  S:=FList.items[i];
  StringGrid1.Cells[0,i+1]:=inttoStr(i+1);
  StringGrid1.Cells[1,i+1]:=S.Name;
  StringGrid1.Cells[2,i+1]:=S.path;
  StringGrid1.Cells[3,i+1]:=datetostr(S.DDel);
  StringGrid1.Cells[4,i+1]:=datetostr(S.DAdd);
  StringGrid1.Cells[5,i+1]:=inttostr(S.Size);
  end;
 end     
 else
begin
stringgrid1.RowCount:=2;
  StringGrid1.Cells[0,1]:='';
  StringGrid1.Cells[1,1]:='';
  StringGrid1.Cells[2,1]:='';
  StringGrid1.Cells[3,1]:='';
  StringGrid1.Cells[4,1]:='';
  StringGrid1.Cells[5,1]:='';
end;
save.Execute;
end;

procedure TForm1.SaveExecute(Sender: TObject);
var
ddd:tdatetime;
DeletedFile:TMyFile;
begin
FList.SaveItems(extractfilepath(application.ExeName)+'\recycled.rcc');

end;

procedure TForm1.LoadExecute(Sender: TObject);
begin
FList.loaditems(extractfilepath(application.ExeName)+'\recycled.rcc');
refresh.Execute;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
Flist.destroy;
end;

procedure TForm1.DeleteExecute(Sender: TObject);
begin
Flist.DelFile(form3.filelistbox1.filename);
form3.filelistbox1.update;
refresh.Execute;
end;

procedure TForm1.BitBtn4Click(Sender: TObject);
begin
flist.Restore(stringgrid1.Row-1);
refresh.Execute;
end;
   
procedure TForm1.ClearbinExecute(Sender: TObject);
var
cnt:byte;
begin
cnt:=Flist.ClearBin;
if cnt>0 then
messageDLG(inttostr(cnt)+' ()  ()',mtInformation	,[mbok],0);
refresh.Execute;
end;

procedure TForm1.RestoreallExecute(Sender: TObject);
var
cnt:byte;
begin
cnt:=Flist.RestoreAll;
if cnt>0 then
messageDLG(inttostr(cnt)+' ()  ()',mtInformation	,[mbok],0);
refresh.Execute;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
form3.ShowModal;
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
var
i:integer;
begin
{form1.AlphaBlend:=true;
form1.AlphaBlendValue:=255;
i:=255;
repeat
i:=i-15;
form1.AlphaBlendValue:=i;
until i<=0;}
close;
end;

procedure TForm1.BitBtn7Click(Sender: TObject);
begin
edit1.Text:=copy(stringgrid1.Cells[1,stringgrid1.row],0,pos('.',stringgrid1.Cells[1,stringgrid1.row])-1)
end;

procedure TForm1.BitBtn8Click(Sender: TObject);
begin
edit2.Text:=copy(stringgrid1.Cells[1,stringgrid1.row],pos('.',stringgrid1.Cells[1,stringgrid1.row])+1,length(stringgrid1.Cells[1,stringgrid1.row]));
end;

procedure TForm1.BitBtn9Click(Sender: TObject);
begin
edit3.Text:=stringgrid1.Cells[2,stringgrid1.row];
end;

procedure TForm1.BitBtn10Click(Sender: TObject);
begin
edit4.Text:=stringgrid1.Cells[3,stringgrid1.row];
end;
    
procedure TForm1.BitBtn11Click(Sender: TObject);
begin
edit5.Text:=stringgrid1.Cells[4,stringgrid1.row];
end;
             

procedure TForm1.CloseOpenPanelExecute(Sender: TObject);
begin
 if opened
 then
  begin
  form1.Height:=form1.Height-115;
  opened:=false;
  Panel1.Caption:=' >>';
 end
else
 begin
  form1.Height:=form1.Height+115;
  opened:=true;
  Panel1.Caption:=' <<';  
 end;
end;

procedure TForm1.DelMaskExecute(Sender: TObject);
begin
if messagedlg('   ?',mtWarning,mbYesNoCancel,0)=mrYes then
messageDLG(inttostr(Flist.OperMask(edit1.Text,edit2.Text,edit3.Text,edit4.Text,edit5.Text, true))+' ()  ()',mtInformation	,[mbok],0);
refresh.Execute;
end;

procedure TForm1.RestMaskExecute(Sender: TObject);
begin
if messagedlg('   ?',mtWarning,mbYesNoCancel,0)=mrYes then
messageDLG(inttostr(Flist.OperMask(edit1.Text,edit2.Text,edit3.Text,edit4.Text,edit5.Text, false))+' ()  ()',mtInformation	,[mbok],0);
refresh.Execute;
end;

procedure TForm1.Restore1Click(Sender: TObject);
begin
flist.Restore(stringgrid1.Row-1);
refresh.Execute;

end;

procedure TForm1.BitBtn13Click(Sender: TObject);
begin
flist.kill(stringgrid1.Row-1);
refresh.Execute;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
i:integer;
begin
stringgrid1.RowCount:=256;
for i:= 1 to 255 do
begin
stringgrid1.cells[1,i]:=inttostr(i);
stringgrid1.cells[2,i]:=chr(i);
end;

end;

procedure TForm1.BitBtn14Click(Sender: TObject);
begin
form4.ShowModal;
end;

end.
