unit kernel;

interface
uses   Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, idglobal,
  Dialogs, Grids, ActnList, StdCtrls, Buttons;
        {TMyFile Declaration}
Type TMyFile=class
 Name,
 NewName,
 Path:string[128];
 DAdd,
 DDel:TDateTime;
 Size:longint;

 Public
 Procedure save(stream:Tstream);
 procedure Load(stream:Tstream);
 Constructor create(Na,nn,Pa:string; Dad,Dde:TdateTime; Siz:longint);
end;{tmyfile}

        {TFileList Declaration}
Tfilelist=class(TList)
destructor destroy; override;
public
procedure DelInfo(ind:word);
procedure DelFile(Delfname:string);
Procedure Restore(ind:word);
Procedure Kill(ind:word);
Function OperMask(fn,fe,pt,Dde,Dad:string; Delete:boolean):integer;
procedure SaveItems(FileName:string);
procedure LoadItems(FileName:string);
Function ClearBin:integer;
Function RestoreAll:integer;
end;{tfilelist}


Var
FList:TFileList;
implementation

        {TMyFile implementation}
constructor TMyfile.create(Na,nn,Pa:string; Dad,Dde:TdateTime; Siz:longint);
begin
 name:=na;
 NewName:=nn;
 Path:=pa;
 Ddel:=dde;
 Dadd:=dad;
 Size:=siz;
end;

procedure TMyfile.load(stream:Tstream);
begin
 try
  stream.Read(Name, sizeof(Name));
  stream.Read(Newname, sizeof(NewName));
  stream.Read(path, sizeof(path));
  stream.Read(Dadd, sizeof(DAdd));
  stream.Read(DDel, sizeof(DDel));
  stream.read(Size, sizeof(Size));
 except
on EInOutError do showmessage('    !');
end;
end;

procedure TMyfile.Save(Stream:TStream);
begin
 try
  stream.Write(Name, sizeof(Name));
  stream.Write(NewName, sizeof(NewName));
  stream.Write(path, sizeof(path));
  stream.Write(Dadd, sizeof(DAdd));
  stream.Write(DDel, sizeof(DDel));
  stream.Write(Size, sizeof(Size));
 except
on EInOutError do ShowMessage('     '+#13+Name+#9+path+#9+datetostr(DDel)+#9+datetostr(Dadd)+#9+InttoStr(size));
end;
end;

        {TFileList implementation}
procedure TFileList.Loaditems(FileName:string);
var
Stream:TStream;
OurFile:TMyfile;
Date:Tdatetime;
begin
try
 try
  Stream:=Tfilestream.Create(Filename,fmOpenRead);
   while Stream.Position<>stream.Size do
        begin
        OurFile:=TMyfile.create('','','',date,date,0);
        OurFile.load(stream);
        add(OurFile);
        end;
   except
   showmessage('   ');
   end;
  finally
  stream.free;
 end;
end;

procedure TFileList.SaveItems(FileName:string);
var
Stream:TStream;
i:word;
begin
 try
  try
    Stream:=TFileStream.Create(FileName,fmCreate);
      if Count<>0 then
        for i:=0 to Count-1 do
        TMyfile(Items[i]).Save(Stream);
  except
  ShowMessage('  i '+#13+FileName);
  end;
      finally
    Stream.Free;
  end;
end;

destructor TFileList.destroy;
var
i:word;
begin
if Count<>0 then
for i:=0 to Count-1 do
TMyfile(Items[i]).free;
inherited;
end;

procedure TFileList.Delinfo(ind:word);
begin
TMyFile(FList.Items[ind]).free;
Flist.Delete(ind);
end;

procedure TFileList.DelFile(DelFName:string);
var
ddd:tdatetime;
NewName:string;
DeletedFile:TMyFile;
begin
randomize;                         
ddd:=date;                      {1/59604644775390625}
NewName:=chr(97+random(122-97))+chr(97+random(122-97))+chr(97+random(122-97))+chr(97+random(122-97))+chr(97+random(122-97))+chr(97+random(122-97))+chr(97+random(122-97))+chr(97+random(122-97))+'-'+chr(65+random(90-65))+chr(65+random(90-65))+chr(65+random(90-65))+chr(65+random(90-65))+'_'+inttostr(FileSizeByName(DelfName));
 deletedfile:=tmyfile.create(extractfilename(DelFName),NewName,extractfilepath(DelfName),FileDateToDateTime(FileAge(DelfName)),date,FileSizeByName(DelfName));
 Flist.Add(deletedfile);
 copyFile(pchar(delfname),pchar(extractfilepath(application.ExeName)+'\r\'+NewName),false);
 deletefile(delfname);
end;

procedure TFileList.Restore(ind:word);
var
s:tmyfile;
begin
if (flist.Count>0) and (ind<flist.Count) then
begin
S:=FList.items[ind];
copyFile(pchar(extractfilepath(application.ExeName)+'\r\'+s.NewName),pchar(s.Path+'\'+s.Name),true);
deletefile(pchar(extractfilepath(application.ExeName)+'\r\'+s.NewName));
delinfo(ind);
end;
end;        

procedure TFileList.kill(ind:word);
var
s:tmyfile;
begin
if messagedlg('  ?',mtWarning,mbYesNoCancel,0)=mrYes then
if (flist.Count>0) and (ind<flist.Count) then
begin
S:=FList.items[ind];
deletefile(pchar(extractfilepath(application.ExeName)+'\r\'+s.NewName));
delinfo(ind);
end;
end;

Function TFileList.ClearBin:integer;
var
i,c:integer;
s:tmyfile;
begin
c:=flist.Count;
if messagedlg('  ?',mtWarning,mbYesNoCancel,0)=mrYes then
if c<>0 then
 begin
  for i:= 0 to c-1 do
   begin
   s:=Flist.items[0];
   deletefile(pchar(extractfilepath(application.ExeName)+'\r\'+s.NewName));
   delinfo(0);
   end;
 result:= i;
 end
else
result:=0
else
result:=0
end;

Function TFileList.RestoreAll:integer;
var
i,c:integer;
begin
c:=flist.Count;

if c>0 then
begin
 for i:= 0 to c-1 do
  begin
  restore(0);
  end;
 result:= i;
end
else
result:=0;
end;

Function TFileList.OperMask(fn,fe,pt,Dde,Dad:string; Delete:boolean):integer;
var
s:TMyFile;
cnt,i:Integer;
begin
i:=flist.Count-1;
if flist.Count>0 then
repeat
begin
S:=FList.items[i];
if (copy(s.name,0,pos('.',s.Name)-1)=fn) or (fn='') then          { }
 if (copy(s.name,pos('.',s.Name)+1,length(s.Name))=fe) or (fe='') then          { }
  if (s.Path=pt) or (pt='') then          { }
   if (datetostr(s.dadd)=dad) or (dad='') then          { }
    if (datetostr(s.ddel)=dde) or (dde='') then          { }
     begin
if delete then
        begin
        {     copyFile(pchar(extractfilepath(application.ExeName)+'\r\'+s.NewName),pchar(s.Path+'\'+s.Name),true);}
             deletefile(pchar(extractfilepath(application.ExeName)+'\r\'+s.NewName));
             inc(cnt);
             delinfo(i);
        end
else
        begin
             copyFile(pchar(extractfilepath(application.ExeName)+'\r\'+s.NewName),pchar(s.Path+'\'+s.Name),true);
             deletefile(pchar(extractfilepath(application.ExeName)+'\r\'+s.NewName));
             inc(cnt);
             delinfo(i);
        end;

     end;
    end;
    dec(i);
    until i=-1;
result:=cnt;
end;




end.
